/*
	Plugin : XmasManager
	Version : 2.5.8
	Author : BIGs
	Strings : 806
	Site : https://hl-hev.ru
*/
#include <amxmodx>
#include <amxmisc>
#include <fun>
#include <fakemeta_util>
#include <hamsandwich>
#include <engine>

#pragma semicolon 1
#pragma ctrlchar  '\'

#define PLUGIN "XmasManager"
#define VERSION "2.5.8"
#define AUTHOR "BIGs"

//Models
#define MDL_SNOW_MAN 	"models/xmas/snow_man.mdl"
#define MDL_TREE 	"models/xmas/tree.mdl"
#define MDL_SWEET 	"models/xmas/sweet.mdl"
#define MDL_PRES 	"models/xmas/present.mdl"
//Sounds
#define SND_SNOW_MAN	"xmas/snow_man.wav"
//Sprites
#define SNOW_SPRITE "sprites/xmas/snow.spr"
//Others
#define get_bit(%1,%2)  (%1 & (1 << (%2 & MAXCLIENTS-1)))
#define set_bit(%1,%2)  (%1 |= (1 << (%2 & MAXCLIENTS-1)))
#define reset_bit(%1,%2)        (%1 &= ~(1 << (%2 & MAXCLIENTS-1)))
           
#define MAXCLIENTS 32
#define CLASSNAME "SnowEntity"
//    .
new g_bAlive;

new g_iSpriteSnow;
new g_iMaxPlayers;

new file[128];
new Float:time_r , timer , Float:coolD ;
//Hats
#define HAT_B	"models/xmas/hat_blue.mdl"
#define HAT_R	"models/xmas/hat_red.mdl"
new g_bwEnt[33];
new g_CachedStringInfoTarget;

new trees , sweets ,sm ,pres;
//Cvars
new color , cool_down , snow ,aura ,hat_cv;
public plugin_init() {
	register_plugin(PLUGIN, VERSION, AUTHOR);
	register_clcmd("xm_menu", "ShowMenu", ADMIN_ADMIN, "");
	
	file = "addons/amxmodx/data/xmas";
	
	register_clcmd("xm_menu_rotate" , "Rotator", ADMIN_ADMIN, "");
	register_touch("snow_man" , "player" , "man_touch");
	
	set_task(0.1 , "get_t");
	set_task(1.0 , "check");
	
	//Commands
	register_concmd("get_list" ,"get_list_ent");
	
	//Cvars
	color = register_cvar("xm_glow" , "1");
	cool_down = register_cvar("xm_cd" ,"30");
	snow = register_cvar("xm_snow" ,"1");
	aura = register_cvar("xm_aura" ,"0");
	hat_cv = register_cvar("xm_hats" ,"1");
	register_cvar("XmasManagerVersion" ,VERSION ,FCVAR_SERVER);
	
	if(file_exists("addons/amxmodx/configs/xm_config.cfg"))
	{
		server_cmd("exec addons/amxmodx/configs/xm_config.cfg");
		server_print("[XmasManager] : Config status - loaded!");
	}else{
		server_print("[XmasManager] : Config status - not loaded!");
	}
	
	
	//Snow
	if(get_pcvar_num(snow) == 1)
	{
		new iSnow = create_entity("info_target");
		entity_set_string(iSnow, EV_SZ_classname, CLASSNAME);
		entity_set_float(iSnow, EV_FL_nextthink, get_gametime() + 2.0);
		register_think(CLASSNAME, "ThinkSnow");
	    
		RegisterHam(Ham_Spawn, "player", "Ham_PlayerSpawn_Post", 1);
		RegisterHam(Ham_Killed, "player", "HamPlayerKilled_Post", 1);		
	}
    
	g_iMaxPlayers = get_maxplayers();
	
	//Hats
	RegisterHam(Ham_Spawn, "player", "fwHamPlayerSpawnPost", 1);
	g_CachedStringInfoTarget = engfunc( EngFunc_AllocString, "info_target" );
}
public fwHamPlayerSpawnPost( const player ) 
{
	switch(get_pcvar_num(hat_cv))
	{
		case 0:
		{
			
		}
		case 1:
		{
			if(is_user_alive( player ))
			{
				new iEnt = g_bwEnt[ player ];
				if( !pev_valid( iEnt ) ) {
				g_bwEnt[ player ] = iEnt = engfunc ( EngFunc_CreateNamedEntity, g_CachedStringInfoTarget );
				set_pev( iEnt, pev_movetype, MOVETYPE_FOLLOW );
				set_pev( iEnt, pev_aiment, player );
				if(get_user_flags(player) & ADMIN_BAN)
				{
					engfunc( EngFunc_SetModel, iEnt, HAT_B);
				}else{
					engfunc( EngFunc_SetModel, iEnt,HAT_R);
				}
				}
			}
		}
		case 2:
		{
			if(is_user_alive( player ))
			{
				new iEnt = g_bwEnt[ player ];
				if( !pev_valid( iEnt ) ) {
				g_bwEnt[ player ] = iEnt = engfunc ( EngFunc_CreateNamedEntity, g_CachedStringInfoTarget );
				set_pev( iEnt, pev_movetype, MOVETYPE_FOLLOW );
				set_pev( iEnt, pev_aiment, player );
				if(get_user_flags(player) & ADMIN_BAN)
				{
					engfunc( EngFunc_SetModel, iEnt, HAT_R);
				}else{
					engfunc( EngFunc_SetModel, iEnt,HAT_B);
				}
				}
			}
		}
	}
}
public get_list_ent()
{
	new iFile = fopen(file, "rt");
	
	if(!iFile)
		return;
	new Float:vOrigin[ 3 ] ,Float:cAngles[3], x[ 16 ], y[ 16 ], z[ 16 ] ,n[16] ,ang_x[16],ang_y[16],ang_z[16], szData[ sizeof( x ) + sizeof( y ) + sizeof( z ) + sizeof(n)+ sizeof(ang_x)+ sizeof(ang_y)+ sizeof(ang_z) + 3 ];

	
	while( !feof( iFile ) ) {
		fgets( iFile, szData, charsmax( szData ) );
		trim( szData );
		
		if( !szData[ 0 ] )
			continue;
		
		parse( szData, x, 15, y, 15, z, 15 ,n ,15 ,ang_x ,15,ang_y ,15,ang_z ,15);
		
		vOrigin[0] = str_to_float( x );
		vOrigin[1] = str_to_float( y );
		vOrigin[2] = str_to_float( z );
		
		cAngles[0] = str_to_float(ang_x);
		cAngles[1] = str_to_float(ang_y);
		cAngles[2] = str_to_float(ang_z);
		new i = str_to_num(n);
		//server_print("[List] : %f %f %f" ,vOrigin[ 0 ] , vOrigin[ 1 ], vOrigin[ 2 ]);
		switch(i)
		{
			case 0:
			{
				server_print("[XMas|List] : %f %f %f (SnowMan)" ,vOrigin[ 0 ] , vOrigin[ 1 ], vOrigin[ 2 ]);
			}
			case 1:
			{
				server_print("[XMas|List] : %f %f %f (Xmas Tree)" ,vOrigin[ 0 ] , vOrigin[ 1 ], vOrigin[ 2 ]);
			}
			case 2:
			{
				server_print("[XMas|List] : %f %f %f (Sweet J)" ,vOrigin[ 0 ] , vOrigin[ 1 ], vOrigin[ 2 ]);
			}
			case 3:
			{
				server_print("[XMas|List] : %f %f %f (Presents)" ,vOrigin[ 0 ] , vOrigin[ 1 ], vOrigin[ 2 ]);
			}
		}
	}
	
	fclose( iFile );	
	
	
}
//Cooldown
public check()
{
	timer--;
}
public get_t()
{
	time_r = get_gametime();
}
public plugin_precache()
{
	precache_model(MDL_SNOW_MAN);
	precache_model(MDL_SWEET);
	precache_model(MDL_TREE);
	precache_model(MDL_PRES);
	
	precache_model(HAT_B);
	precache_model(HAT_R);
	
	precache_sound(SND_SNOW_MAN);
	
	g_iSpriteSnow = precache_model(SNOW_SPRITE);
}
public man_touch(iEntity , id)
{
	if(!pev_valid(iEntity))
		return PLUGIN_HANDLED;
	time_r = get_gametime();
	if(time_r > coolD)
	{
		emit_sound(iEntity,CHAN_STATIC,SND_SNOW_MAN,0.5,ATTN_NORM,0,PITCH_NORM);
		timer = get_pcvar_num(cool_down);
		set_task(0.01 , "ter");
	}
	return PLUGIN_HANDLED;
}
//Cooldown
public ter()
{
	coolD = get_gametime() + timer;
}
public plugin_cfg()
{
	new sz_map[128];
	get_mapname(sz_map,127);
	strtolower(sz_map);
	
	if( !dir_exists(file) ) {
		mkdir( file);
			
		format(file, 127, "%s/%s.txt", file, sz_map );
		return;
	}
	
	format(file, 127, "%s/%s.txt", file, sz_map );
	if(!file_exists(file))
		return;
		
	new iFile = fopen(file, "rt");
	
	if(!iFile)
		return;
	new Float:vOrigin[ 3 ] ,Float:cAngles[3], x[ 16 ], y[ 16 ], z[ 16 ] ,n[16] ,ang_x[16],ang_y[16],ang_z[16], szData[ sizeof( x ) + sizeof( y ) + sizeof( z ) + sizeof(n)+ sizeof(ang_x)+ sizeof(ang_y)+ sizeof(ang_z) + 3 ];

	
	while( !feof( iFile ) ) {
		fgets( iFile, szData, charsmax( szData ) );
		trim( szData );
		
		if( !szData[ 0 ] )
			continue;
		
		parse( szData, x, 15, y, 15, z, 15 ,n ,15 ,ang_x ,15,ang_y ,15,ang_z ,15);
		
		vOrigin[0] = str_to_float( x );
		vOrigin[1] = str_to_float( y );
		vOrigin[2] = str_to_float( z );
		
		cAngles[0] = str_to_float(ang_x);
		cAngles[1] = str_to_float(ang_y);
		cAngles[2] = str_to_float(ang_z);
		//server_print("[List] : %f %f %f" ,vOrigin[ 0 ] , vOrigin[ 1 ], vOrigin[ 2 ]);
		new wn = str_to_num(n);
		start_spawns(vOrigin ,wn ,cAngles);
		//server_print("[List] : %f %f %f" ,cAngles[0] , cAngles[1] , cAngles[2]);
		
		switch(wn)
		{
			case 0:
			{
				sm++;
			}
			case 1:
			{
				trees++;
			}
			case 2:
			{
				sweets++;
			}
			case 3:
			{
				pres++;
			}
		}
		
	}
	
	fclose( iFile );	
	
	server_print("[XmasManager] : Map - %s | Trees:%d | SnowMan:%d | Sweets J:%d | Presents:%d |" , sz_map , trees ,sm ,sweets ,pres);
	
}
start_spawns(Float:Origins [3],lev ,Float:ang[3])
{
	switch(lev)
	{
		case 0:
		{
			new iEntity = create_entity("info_target");
			
			if(!pev_valid(iEntity))
				return PLUGIN_HANDLED;
			
			set_pev(iEntity, pev_origin, Origins);
			set_pev(iEntity, pev_angles, ang);
			set_pev(iEntity, pev_classname, "snow_man");
			set_pev(iEntity, pev_solid, SOLID_BBOX);
			set_pev(iEntity, pev_movetype, MOVETYPE_NONE);
			set_pev(iEntity, pev_sequence, 0);
			set_pev(iEntity, pev_framerate, 1.0);
			set_pev(iEntity, pev_nextthink, get_gametime() + 1.0);
				
			engfunc(EngFunc_SetModel, iEntity,MDL_SNOW_MAN);
			engfunc(EngFunc_SetSize, iEntity, Float:{-16.0, -16.0, -48.0}, Float:{16.0, 16.0, 48.0});
			//Glow Shell
			if(get_pcvar_num(color))
				set_rendering( iEntity,kRenderFxGlowShell,random_num(50 , 255),random_num(50 , 255),random_num(50 , 255),kRenderFxNone,20);
			
			drop_to_floor(iEntity);
			
			if(get_pcvar_num(aura) == 1)
				set_pev(iEntity, pev_effects, EF_BRIGHTLIGHT);
		}
		case 1:
		{
			new iEntity = create_entity("info_target");
			
			if(!pev_valid(iEntity))
				return PLUGIN_HANDLED;
			
			set_pev(iEntity, pev_origin,Origins);
			set_pev(iEntity, pev_angles, ang);
			set_pev(iEntity, pev_classname, "tree");
			set_pev(iEntity, pev_solid, SOLID_BBOX);
			set_pev(iEntity, pev_movetype, MOVETYPE_NONE);
			set_pev(iEntity, pev_sequence, 0);
			set_pev(iEntity, pev_framerate, 1.0);
			set_pev(iEntity, pev_nextthink, get_gametime() + 1.0);
				
			engfunc(EngFunc_SetModel, iEntity,MDL_TREE);
			engfunc(EngFunc_SetSize, iEntity, Float:{-16.0, -16.0, -72.0}, Float:{16.0, 16.0, 72.0});
			//Glow Shell
			if(get_pcvar_num(color))
				set_rendering( iEntity,kRenderFxGlowShell,random_num(50 , 255),random_num(50 , 255),random_num(50 , 255),kRenderFxNone,20);

			drop_to_floor(iEntity);
			
			if(get_pcvar_num(aura) == 1)
				set_pev(iEntity, pev_effects, EF_BRIGHTLIGHT);
		}
		case 2:
		{
			new iEntity = create_entity("info_target");
			
			if(!pev_valid(iEntity))
				return PLUGIN_HANDLED;
			
			set_pev(iEntity, pev_origin, Origins);
			set_pev(iEntity, pev_angles, ang);
			set_pev(iEntity, pev_classname, "sweet");
			set_pev(iEntity, pev_solid, SOLID_BBOX);
			set_pev(iEntity, pev_movetype, MOVETYPE_NONE);
			set_pev(iEntity, pev_sequence, 0);
			set_pev(iEntity, pev_framerate, 1.0);
			set_pev(iEntity, pev_nextthink, get_gametime() + 1.0);
				
			engfunc(EngFunc_SetModel, iEntity,MDL_SWEET);
			engfunc(EngFunc_SetSize, iEntity, Float:{-16.0, -16.0, -72.0}, Float:{16.0, 16.0, 72.0});
			//Glow Shell
			if(get_pcvar_num(color))
				set_rendering( iEntity,kRenderFxGlowShell,random_num(50 , 255),random_num(50 , 255),random_num(50 , 255),kRenderFxNone,20);
			
			drop_to_floor(iEntity);
			
			if(get_pcvar_num(aura) == 1)
				set_pev(iEntity, pev_effects, EF_BRIGHTLIGHT);
		}
		case 3:
		{
			new iEntity = create_entity("info_target");
			
			if(!pev_valid(iEntity))
				return PLUGIN_HANDLED;
			
			set_pev(iEntity, pev_origin, Origins);
			set_pev(iEntity, pev_angles, ang);
			set_pev(iEntity, pev_classname, "present");
			set_pev(iEntity, pev_solid, SOLID_BBOX);
			set_pev(iEntity, pev_movetype, MOVETYPE_NONE);
			set_pev(iEntity, pev_sequence, 0);
			set_pev(iEntity, pev_framerate, 1.0);
			set_pev(iEntity, pev_nextthink, get_gametime() + 1.0);
				
			engfunc(EngFunc_SetModel, iEntity,MDL_PRES);
			engfunc(EngFunc_SetSize, iEntity, Float:{-16.0, -16.0, -24.0}, Float:{16.0, 16.0, 24.0});
			//Glow Shell
			if(get_pcvar_num(color))
				set_rendering( iEntity,kRenderFxGlowShell,random_num(50 , 255),random_num(50 , 255),random_num(50 , 255),kRenderFxNone,20);
			
			drop_to_floor(iEntity);
			
			if(get_pcvar_num(aura) == 1)
				set_pev(iEntity, pev_effects, EF_BRIGHTLIGHT);
		}
	}
	return PLUGIN_HANDLED;
}
public ShowMenu(id, lvl, cid)
{
	if(!cmd_access(id, lvl, cid, 0))
		return PLUGIN_HANDLED;

	new menu = menu_create("XmasManager", "xmas_menu");

	menu_additem(menu, "AddMenu", "", 0); // case 0
	menu_additem(menu, "Remover", "", 0); // case 1
	menu_additem(menu, "Rotator", "", 0); // case 2
	
	menu_setprop(menu,MPROP_EXIT, MEXIT_ALL);
	menu_display(id, menu);

	return PLUGIN_HANDLED;
}
public xmas_menu(id, menu, item)
{
	if(item==MENU_EXIT)
		menu_destroy(menu);
		
	switch(item)
	{
		case 0:
		{
			ShowMenuSpawn(id);
		}
		case 1:
		{
			menu_display(id, menu);
			remover(id);
		}
		case 2:
		{
			client_cmd(id ,"xm_menu_rotate");		
		}
	}
}
public ShowMenuSpawn(id)
{
	new menu = menu_create("XmasManager [Spawn]", "xmas_spawn_menu");

	menu_additem(menu, "Add : Snow Man", "", 0); // case 0
	menu_additem(menu, "Add : Tree", "", 0); // case 1
	menu_additem(menu, "Add : Sweet J", "", 0); // case 2
	menu_additem(menu, "Add : Present", "", 0); // case 3
	
	menu_setprop(menu,MPROP_EXIT, MEXIT_ALL);
	menu_display(id, menu);

	return PLUGIN_HANDLED;
}
public xmas_spawn_menu(id, menu, item)
{
	if(item==MENU_EXIT)
		menu_destroy(menu);
		
	new Float:vOrigin[3];
	switch(item)
	{
		case 0: 
		{
			menu_display(id ,menu);
			fm_get_aim_origin(id , vOrigin);
			new iEntity = create_entity("info_target");
			
			if(!pev_valid(iEntity))
				return PLUGIN_HANDLED;
			
			set_pev(iEntity, pev_origin, vOrigin);
			set_pev(iEntity, pev_classname, "snow_man");
			set_pev(iEntity, pev_solid, SOLID_BBOX);
			set_pev(iEntity, pev_movetype, MOVETYPE_NONE);
			set_pev(iEntity, pev_sequence, 0);
			set_pev(iEntity, pev_framerate, 1.0);
			set_pev(iEntity, pev_nextthink, get_gametime() + 1.0);
				
			engfunc(EngFunc_SetModel, iEntity,MDL_SNOW_MAN);
			engfunc(EngFunc_SetSize, iEntity, Float:{-16.0, -16.0, -50.0}, Float:{16.0, 16.0, 50.0});
			//Glow Shell
			if(get_pcvar_num(color))
				set_rendering( iEntity,kRenderFxGlowShell,random_num(50 , 255),random_num(50 , 255),random_num(50 , 255),kRenderFxNone,20);
			
			drop_to_floor(iEntity);
			save_xmas();
			client_print(id , print_chat , "[XmasManager] : Spawned ! [X:%f Y:%f Z:%f]" , vOrigin[0] , vOrigin[1], vOrigin[2]);
		}
		case 1: 
		{
			menu_display(id, menu);
			fm_get_aim_origin(id , vOrigin);
			new iEntity = create_entity("info_target");
			
			if(!pev_valid(iEntity))
				return PLUGIN_HANDLED;
			
			set_pev(iEntity, pev_origin, vOrigin);
			set_pev(iEntity, pev_classname, "tree");
			set_pev(iEntity, pev_solid, SOLID_BBOX);
			set_pev(iEntity, pev_movetype, MOVETYPE_NONE);
			set_pev(iEntity, pev_sequence, 0);
			set_pev(iEntity, pev_framerate, 1.0);
			set_pev(iEntity, pev_nextthink, get_gametime() + 1.0);
				
			engfunc(EngFunc_SetModel, iEntity,MDL_TREE);
			engfunc(EngFunc_SetSize, iEntity, Float:{-16.0, -16.0, -72.0}, Float:{16.0, 16.0, 72.0});
			//Glow Shell
			if(get_pcvar_num(color))
				set_rendering( iEntity,kRenderFxGlowShell,random_num(50 , 255),random_num(50 , 255),random_num(50 , 255),kRenderFxNone,20);
			
			
			drop_to_floor(iEntity);
			save_xmas();
			client_print(id , print_chat , "[XmasManager] : Spawned ! [X:%f Y:%f Z:%f]" , vOrigin[0] , vOrigin[1], vOrigin[2]);
		}
		case 2: 
		{
			menu_display(id, menu);
			fm_get_aim_origin(id , vOrigin);
			new iEntity = create_entity("info_target");
			
			if(!pev_valid(iEntity))
				return PLUGIN_HANDLED;
			
			set_pev(iEntity, pev_origin, vOrigin);
			set_pev(iEntity, pev_classname, "sweet");
			set_pev(iEntity, pev_solid, SOLID_BBOX);
			set_pev(iEntity, pev_movetype, MOVETYPE_NONE);
			set_pev(iEntity, pev_sequence, 0);
			set_pev(iEntity, pev_framerate, 1.0);
			set_pev(iEntity, pev_nextthink, get_gametime() + 1.0);
				
			engfunc(EngFunc_SetModel, iEntity,MDL_SWEET);
			engfunc(EngFunc_SetSize, iEntity, Float:{-16.0, -16.0, -72.0}, Float:{16.0, 16.0, 72.0});
			
			//Glow Shell
			if(get_pcvar_num(color))
				set_rendering( iEntity,kRenderFxGlowShell,random_num(50 , 255),random_num(50 , 255),random_num(50 , 255),kRenderFxNone,20);

			drop_to_floor(iEntity);
			save_xmas();
			client_print(id , print_chat , "[XmasManager] : Spawned ! [X:%f Y:%f Z:%f]" , vOrigin[0] , vOrigin[1], vOrigin[2]);
		}
		case 3: 
		{
			menu_display(id, menu);
			fm_get_aim_origin(id , vOrigin);
			new iEntity = create_entity("info_target");
			
			if(!pev_valid(iEntity))
				return PLUGIN_HANDLED;
			
			set_pev(iEntity, pev_origin, vOrigin);
			set_pev(iEntity, pev_classname, "present");
			set_pev(iEntity, pev_solid, SOLID_BBOX);
			set_pev(iEntity, pev_movetype, MOVETYPE_NONE);
			set_pev(iEntity, pev_sequence, 0);
			set_pev(iEntity, pev_framerate, 1.0);
			set_pev(iEntity, pev_nextthink, get_gametime() + 1.0);
				
			engfunc(EngFunc_SetModel, iEntity,MDL_PRES);
			engfunc(EngFunc_SetSize, iEntity, Float:{-16.0, -16.0, -24.0}, Float:{16.0, 16.0,24.0});
			
			//Glow Shell
			if(get_pcvar_num(color))
				set_rendering( iEntity,kRenderFxGlowShell,random_num(50 , 255),random_num(50 , 255),random_num(50 , 255),kRenderFxNone,20);

			drop_to_floor(iEntity);
			save_xmas();
			client_print(id , print_chat , "[XmasManager] : Spawned ! [X:%f Y:%f Z:%f]" , vOrigin[0] , vOrigin[1], vOrigin[2]);
		}
	}
	return PLUGIN_CONTINUE;
}
public Rotator(id, lvl, cid)
{
	if(!cmd_access(id, lvl, cid, 0))
		return PLUGIN_HANDLED;

	new menu = menu_create("XmasManager [Rotator]", "xmas_rotator");

	menu_additem(menu, "[Y]: Right", "", 0); // case 0
	menu_additem(menu, "[Y]: Left", "", 0); // case 1
	menu_setprop(menu,MPROP_EXIT, MEXIT_ALL);
	//menu_setprop(menu, MPROP_EXIT, MEXIT_NEVER);
	menu_display(id, menu);

	return PLUGIN_HANDLED;
}
public xmas_rotator(id, menu, item)
{
	if(item==MENU_EXIT)
		menu_destroy(menu);
	
		
	//new command[6], name[64], access, callback;

	//menu_item_getinfo(menu, item, access, command, sizeof command - 1, name, sizeof name - 1, callback);

	new Float:s_Angle[ 3 ], Float:gOrigin[ 3 ] ,iEntity = -1,  is_class[10];
	//entity_get_vector( id, EV_VEC_angles,s_Angle );
	entity_get_vector( id, EV_VEC_origin, gOrigin );
	switch(item)
	{
		case 0 :
		{
			menu_display(id ,menu);
			while( ( iEntity = find_ent_in_sphere( iEntity, gOrigin, 100.0 ) ) > 0 ) {
			entity_get_string( iEntity, EV_SZ_classname,is_class, 9 );
			entity_get_vector( iEntity, EV_VEC_angles,s_Angle );
		
			if( equal( is_class, "snow_man" ) || equal( is_class, "sweet" ) || equal( is_class, "tree" ) || equal( is_class, "present" )) 
			{
				s_Angle[1] +=25.0;
				if(s_Angle[1] >= 360.0)
					s_Angle[1] = 0.0;
				entity_set_vector(iEntity , EV_VEC_angles ,s_Angle);
				client_print(id , print_chat,"[XmasRotator] : X: %f Y: %f Z: %f" ,s_Angle[0],s_Angle[1],s_Angle[2]);
				save_xmas();
			}
			}
		}
		case 1 :
		{
			menu_display(id ,menu);
			while( ( iEntity = find_ent_in_sphere( iEntity, gOrigin, 100.0 ) ) > 0 ) {
			entity_get_string( iEntity, EV_SZ_classname,is_class, 9 );
			entity_get_vector( iEntity, EV_VEC_angles,s_Angle );
			if( equal( is_class, "snow_man" ) || equal( is_class, "sweet" ) || equal( is_class, "tree" ) || equal( is_class, "present" )) 
			{
				s_Angle[1] -=25.0;
				if(s_Angle[1] <= -360.0)
					s_Angle[1] = 0.0;
				entity_set_vector(iEntity , EV_VEC_angles ,s_Angle);
				client_print(id , print_chat,"[XmasRotator] : X: %f Y: %f Z: %f" ,s_Angle[0],s_Angle[1],s_Angle[2]);
				save_xmas();
			}
			}
		}
	}
	return PLUGIN_HANDLED;
}
public remover(id)
{
		
	new Float:vOrigin[ 3 ], iEntity = -1, iDeleted , x_class[10];
	entity_get_vector( id, EV_VEC_origin, vOrigin );
	
	while( ( iEntity = find_ent_in_sphere( iEntity, vOrigin, 100.0 ) ) > 0 ) {
		entity_get_string( iEntity, EV_SZ_classname,x_class, 9 );
		
		if( equal( x_class, "snow_man" ) ) {
			remove_entity( iEntity );
			client_print(id , print_chat , "[XmasManager] : Removed!" );
			iDeleted++;
		}
	}
	while( ( iEntity = find_ent_in_sphere( iEntity, vOrigin, 100.0 ) ) > 0 ) {
		entity_get_string( iEntity, EV_SZ_classname,x_class, 9 );
		
		if( equal( x_class, "tree" ) ) {
			remove_entity( iEntity );
			client_print(id , print_chat , "[XmasManager] : Removed!" );
			iDeleted++;
		}
	}
	while( ( iEntity = find_ent_in_sphere( iEntity, vOrigin, 100.0 ) ) > 0 ) {
		entity_get_string( iEntity, EV_SZ_classname,x_class, 9 );
		
		if( equal( x_class, "sweet" ) ) {
			remove_entity( iEntity );
			client_print(id , print_chat , "[XmasManager] : Removed!" );
			iDeleted++;
		}
	}
	while( ( iEntity = find_ent_in_sphere( iEntity, vOrigin, 100.0 ) ) > 0 ) {
		entity_get_string( iEntity, EV_SZ_classname,x_class, 9 );
		
		if( equal( x_class, "present" ) ) {
			remove_entity( iEntity );
			client_print(id , print_chat , "[XmasManager] : Removed!" );
			iDeleted++;
		}
	}
	
	if( iDeleted > 0 )
		save_xmas( );
	
	return PLUGIN_HANDLED;
}
save_xmas()
{
	if( file_exists( file) )
	delete_file( file );
	
	new iFile = fopen( file, "wt" );
	
	if( !iFile )
		return;
		
	new  Float:vOrigin[3]  ,Float:Ang[3],iEntity;
	while( ( iEntity = find_ent_by_class( iEntity, "snow_man" ) ) > 0 ) {
		entity_get_vector( iEntity, EV_VEC_origin, vOrigin );
		entity_get_vector(iEntity, EV_VEC_angles,Ang);
		
		fprintf( iFile, "%f %f %f 0 %f %f %f\n", vOrigin[ 0 ], vOrigin[ 1 ], vOrigin[ 2 ] ,Ang[0],Ang[1],Ang[2]);
	}
	while( ( iEntity = find_ent_by_class( iEntity, "tree" ) ) > 0 ) {
		entity_get_vector( iEntity, EV_VEC_origin, vOrigin );
		entity_get_vector(iEntity, EV_VEC_angles,Ang);
		fprintf( iFile, "%f %f %f 1 %f %f %f\n", vOrigin[ 0 ], vOrigin[ 1 ], vOrigin[ 2 ] ,Ang[0],Ang[1],Ang[2]);
	}
	while( ( iEntity = find_ent_by_class( iEntity, "sweet" ) ) > 0 ) {
		entity_get_vector( iEntity, EV_VEC_origin, vOrigin );
		entity_get_vector( iEntity, EV_VEC_angles,Ang);
		fprintf( iFile, "%f %f %f 2 %f %f %f\n", vOrigin[ 0 ], vOrigin[ 1 ], vOrigin[ 2 ] ,Ang[0],Ang[1],Ang[2]);
	}
	while( ( iEntity = find_ent_by_class( iEntity, "present" ) ) > 0 ) {
		entity_get_vector( iEntity, EV_VEC_origin, vOrigin );
		entity_get_vector( iEntity, EV_VEC_angles,Ang);
		fprintf( iFile, "%f %f %f 3 %f %f %f\n", vOrigin[ 0 ], vOrigin[ 1 ], vOrigin[ 2 ] ,Ang[0],Ang[1],Ang[2]);
	}
	
	fclose( iFile );
	
}
public Ham_PlayerSpawn_Post(id)
{
	if(is_user_alive(id)) 
		set_bit(g_bAlive, id);
}
public HamPlayerKilled_Post(id)
{
	reset_bit(g_bAlive, id);
}
public ThinkSnow(ent)
{
	if(get_pcvar_num(snow) == 1)
	{
		entity_set_float(ent, EV_FL_nextthink, get_gametime() + 0.10);
	    
		static id;
		for(id = 1; id <= g_iMaxPlayers; id++)
		{
			if(!get_bit(g_bAlive, id)) 
				continue;
		
			new Float:fOrigin[3], iOrigin[3];
			entity_get_vector(id, EV_VEC_origin, fOrigin);
			FVecIVec(fOrigin, iOrigin);
			iOrigin[0] += random_num(-1000, 1000);
			iOrigin[1] += random_num(-1000, 1000);
			iOrigin[2] += random_num(100, 200);
			UTIL_CreateSnow(iOrigin, g_iSpriteSnow, 1, 1, 2);
		}
	}
}
stock UTIL_CreateSnow(const iOrigin[3], const iSpriteID, const iCount, const iLife, const iScale)
{
	message_begin(MSG_BROADCAST,SVC_TEMPENTITY);
	write_byte(TE_SPRITETRAIL);
	write_coord(iOrigin[0]);
	write_coord(iOrigin[1]);
	write_coord(iOrigin[2]);
	write_coord(iOrigin[0]);
	write_coord(iOrigin[1]);
	write_coord(iOrigin[2]);
	write_short(iSpriteID);
	write_byte(iCount);
	write_byte(iLife);
	write_byte(iScale);
	write_byte(random_num(1, 5));
	write_byte(random_num(1, 8));
	message_end();
}
